require "Penetrator"
ham=require "bresenham"
require 'lovedebug'

function love.load()
	 walls={
		 newRect(57,50,114,50),
		 newRect(171,100,114,100),
		 newRect(342+28*5+5*6+10,50,171,300),
		 newRect(114,400,100,100),
		 newRect(528,500,114,50),
		 newRect(342,400,28,28),
		 newRect(342+28+5,400,28,28),
		 newRect(342+28*2+5*2,400,28,28),
		 newRect(342+28*3+5*3,400,28,28),
		 newRect(342+28*4+5*4,400,28,28),
		 newRect(342+28*5+5*5,400,28,28)
	 } --creating walls
	 
	 light={x=10,y=10,rad=10,seg=100}
	 
	 --line={}
--	 line.ox=400
--	 line.oy=300
--	 line.fx=0
--	 line.fy=300
--	 line.op='-'
--	 line.which='y'
--	 line.start=true
	 love.window.setMode(950,950,{vsync=false,resizable=true})
	 
	 map={
		{'#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#'}, --9
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#','#',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ','#','#',' ',' ',' ',' ','#','#',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ','#','#',' ',' ',' ',' ','#','#',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ','#','#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ','#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#','#',' ',' ',' ',' ','#'},
		{'#',' ',' ','#','#','#',' ',' ',' ',' ',' ',' ','#','#',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ','#',' ','#',' ','#',' ','#',' ','#',' ','#',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ','#',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#'}
	 } --9
	 
	 love.keyboard.setKeyRepeat(true)
end

function love.update(dt)
	 map={
		{'#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#'}, --9
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#','#',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ','#','#',' ',' ',' ',' ','#','#',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ','#','#',' ',' ',' ',' ','#','#',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ','#','#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ','#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#','#',' ',' ',' ',' ','#'},
		{'#',' ',' ','#','#','#',' ',' ',' ','l',' ',' ','#','#',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ','#',' ','#',' ','#',' ','#',' ','#',' ','#',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ','#',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#'},
		{'#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#'}
	 }
	 mapl=map --9 
	 local w={}
	 w.x=0
	 w.y=10
	 local which='y'
	 local op='-'
	 repeat
		 local a=255
		 ham.los(light.x,light.y,w.x,w.y,function(x,y)
			 a=a-20 >=0 and a-20 or 0
			 if mapl[y][x] == '#' or a == 0 then
				 return false
			 else
				 mapl[y][x] = {a=a}
				 return true
			 end
		 end)
		 --print('w.'..which..' is now '..doo(w[which],1,op)..' op is '..op)
		 w[which]=doo(w[which],1,op)
		 if w.x==0 and w.y<=0 then
			 --print('1')
			 w.y=0
			 op='+'
			 which='x'
		 elseif w.y==0 and w.x>=19 then
			 --print('2')
			 w.x=19
			 op='+'
			 which='y'
		 elseif w.y>=19 and w.x==19 then
			 --print('3')
			 w.y=19
			 op='-'
			 which='x'
		 elseif w.y==19 and w.x<=0 then
			 --print('4')
			 w.x=0
			 op='-'
			 which='y'
		 end
	 until w.x==0 and w.y==11
	 light.y,light.x=math.floor(19*love.mouse.getY()/950)+1,math.floor(19*love.mouse.getX()/950)+1
	 mapl[light.y][light.x]='p'
	 --print(math.floor(19*love.mouse.getY()/950)+1,math.floor(19*love.mouse.getX()/950)+1)
	 
	 
end

function love.draw()
	 love.window.setTitle(love.timer.getFPS()..' '..love.timer.getDelta())
	 
	 for y,yy in ipairs(mapl) do
		 for x,xx in ipairs(mapl[y]) do
			 if type(xx)=='table' then
				 love.graphics.setColor(255,255,0,xx.a)
				 love.graphics.rectangle('fill',x*50-50,y*50-50,50,50)
			 elseif xx=='p' then
				 love.graphics.setColor(127,127,0)
				 love.graphics.rectangle('fill',x*50-50,y*50-50,50,50)
			 end
		 end
	 end
	 for y,yy in ipairs(map) do
		 for x,xx in ipairs(map[y]) do
			 if xx=='#' then
				 love.graphics.setColor(255,255,255)
				 love.graphics.rectangle('fill',x*50-50,y*50-50,50,50)
			 end
		 end
	 end
	 
	 
end

function love.keypressed(k)
	 if k=='right' then
		 if map[light.y][light.x+1]~='#' then
			 light.x=light.x+1
		 end
	 elseif k=='left' then
		 if map[light.y][light.x-1]~='#' then
			 light.x=light.x-1
		 end
	 elseif k=='up' then
		 if map[light.y-1][light.x]~='#' then
			 light.y=light.y-1
		 end
	 elseif k=='down' then
		 if map[light.y+1][light.x]~='#' then
			 light.y=light.y+1
		 end
	 end
end

function dtt(a,b)
	 return a*b
end
function doo(a,b,op)
	 if op=='+' then
		 return a+b
	 elseif op=='-' then
		 return a-b
	 end
end
--[[--print('('..tostring(not line.start)..' and not ('..tostring(line.fx==0)..' and '..tostring(line.fy==300)..')) or ('..tostring(line.start)..')')
	--print(tostring((not line.start and line.fx~=0 and line.fy~=300) or (line.start)))
	 if (not line.start and not (line.fx==0 and line.fy==300)) or (line.start) then
		--print('return doo('..line['f'..line.which]..',dtt(1,love.timer.getDelta()))')
		f=assert(loadstring('return doo('..line['f'..line.which]..',1)'))
		line['f'..line.which]=f()
		--print(dtt(1000,love.timer.getDelta()))
		--print(f())
		--print(line.which,line.op)
		if line.fx==0 and line.fy<=0 then
			 --print('1')
			 line.fy=0
			 line.op='+'
			 line.which='x'
		 elseif line.fy==0 and line.fx>=love.window.getWidth() then
			 --print('2')
			 line.fx=love.window.getWidth()
			 line.op='+'
			 line.which='y'
		 elseif line.fy>=love.window.getHeight() and line.fx==love.window.getWidth() then
			 --print('3')
			 line.fy=love.window.getHeight()
			 line.op='-'
			 line.which='x'
		 elseif line.fy==love.window.getHeight() and line.fx<=0 then
			 --print('4')
			 line.fx=0
			 line.op='-'
			 line.which='y'
		 end
	 end
	 line.start=true
	 ]]

--[[for i,v in ipairs(walls) do
		 love.graphics.rectangle('fill',returnRect(v))
	 end
	 love.graphics.circle('fill',light.x,light.y,light.rad,light.seg)
	 love.graphics.line(line.ox,line.oy,line.fx,line.fy)]


--[[for i,v in ipairs(walls) do
		 love.graphics.rectangle('fill',returnRect(v))
	 end
	 love.graphics.circle('fill',light.x,light.y,light.rad,light.seg)
	 love.graphics.line(line.ox,line.oy,line.fx,line.fy)]]